<template>
  <q-card>
    <q-card-section>
      <div class="text-h6">Notification Centre</div>
    </q-card-section>
    <q-card-section>
      <q-list bordered>
        <q-item clickable v-ripple v-for="message in messages" v-bind:key="message.id" @click="selectMessage(message.id)">
          <q-item-section avatar>
            <q-avatar class="bg-grey">
              <div>
                {{message.user.name[0]}}
              </div>
            </q-avatar>
          </q-item-section>
          <q-item-section>
            <q-item-label>
              {{message.user.name}}
            </q-item-label>
            <q-item-label caption>
              {{message.title}}
            </q-item-label>
          </q-item-section>
        </q-item>
      </q-list>
    </q-card-section>

    <!-- Notification Dialog -->
    <q-dialog v-model="notification">
      <q-card style="width: 700px; max-width: 80vw;">
        <q-item>
          <q-item-section avatar>
            <q-avatar class="bg-grey">
              <div>
                {{selected.user.name[0]}}
              </div>
            </q-avatar>
          </q-item-section>

          <q-item-section>
            <q-item-label>{{ selected.title }}</q-item-label>
            <q-item-label caption>
              {{ selected.user.name}}
            </q-item-label>
          </q-item-section>
        </q-item>

        <q-separator />

        <q-card-section>
          {{ selected.message}}
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="OK" color="primary" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-card>
</template>

<script>
import { ref } from 'vue';

export default {
  setup () {
    const messages = ref([{id: 1, user: {name: "Nicola"}, message: "heyo", title: "Test Message"}, {id: 2, user: {name: "Ciro"}, message: "Hallo", title: "Another test"}]);
    const selected_id = ref(0);
    const notification = ref(false);
    const selected = ref(null)

    const selectMessage = (id) => {
      selected_id.value = id;
      selected.value = messages.value.find(message => message.id == selected_id.value);
      notification.value = true;
    }

    return {messages, selected_id, notification, selected, selectMessage}
  }
}
</script>
